﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Evaluant.Uss.ObjectContext.Contracts;
using System.Linq.Expressions;
using System.Reflection;

namespace Evaluant.Uss.Linq
{
    public static class ContextExtensions
    {
        public static IInferrable<T> Cast<T>(this IObjectContextAsync context)
        {
            return new AsyncQueryableUss<T>(context);
        }

        public static IInferrable<T> Cast<T>(this IObjectContext context)
        {
            return new QueryableUss<T>(context);
        }

        public static IInferrable<T> Infer<T, U>(this IObjectContext context, Expression<Func<T, U>> accessor)
        {
            return Infer<T,U>(new QueryableUss<T>(context), accessor);
        }

        public static IInferrable<T> Infer<T, U>(this IInferrable<T> query, Expression<Func<T, U>> accessor)
        {
            return (IInferrable<T>)query.Provider.CreateQuery<T>(Expression.Call(((MethodInfo)MethodBase.GetCurrentMethod()).GetGenericMethodDefinition().MakeGenericMethod(typeof(T),typeof(U)), query.Expression, Expression.Quote(accessor)));
        }
    }
}
