using System;
using UniversalStorageServices;

using DemoNamespace;

namespace BasicTypeAttribute
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Basic Attributes serialization =====");

			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			Entity e = new Entity("Person");
			e.AddValue("Name", "Ottlieb");
			e.AddValue("FirstName", "Sven");
			e.AddValue("Age", 25);

			pe.InitializeRepository();

			Transaction t = new Transaction();
			t.Serialize(e);
			pe.Commit(t);

			EntitySet es = pe.Load("Person", true);
			foreach(Entity entity in es)
			{
				string name = entity.GetString("Name");
				string firstname = entity.GetString("FirstName");
				int age = entity.GetInt32("Age");
				Console.WriteLine(name + " " + firstname + ", " + age);
			}
		}
	}
}
