using System;
using UniversalStorageServices;

using DemoNamespace;

namespace ComplexTypeAttribute
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Complex Attributes serialization =====");

			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			Entity e = new Entity("ComplexInterval");
			e.AddValue("Name", "c1");
			e.AddValue("Min", new DemoNamespace.ComplexNumber(10, 25));
			e.AddValue("Max", new DemoNamespace.ComplexNumber(1, 2));

			pe.InitializeRepository();

			Transaction t = new Transaction();
			t.Serialize(e);
			pe.Commit(t);

			EntitySet es = pe.Load("ComplexInterval", true);
			foreach(Entity entity in es)
			{
				string intervalName = entity.GetString("Name");
				ComplexNumber min = (ComplexNumber)entity.GetValue("Min");
				ComplexNumber max = (ComplexNumber)entity.GetValue("Max");

				Console.WriteLine(intervalName + " = {" + min + " ; " + max + "}");
			}
		}
	}
}
