using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Overview;

namespace EUSSOverview
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			PersistenceManagerFactory pmf = new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Customer c1 = new Customer();
			c1.Name = "Wang";
			c1.Firstname = "Yanf";
			c1.Address = "Hauptstr. 29";
			c1.City = "Berlin";

			Order o1 = new Order();
			o1.Quantity = 1;
			o1.ProductName = "Coffee";
			o1.Date = new DateTime(2005, 02, 20);
			o1.Amount = 11.5;

			Order o2 = new Order();
			o2.Quantity = 2;
			o2.ProductName = "Chocolade";
			o2.Date = new DateTime(2005, 09, 12);
			o2.Amount = 53.4;

			c1.Orders.Add(o1);
			c1.Orders.Add(o2);

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c1);
			pm.CommitTransaction();

			IList customers = pm.Load(typeof(Customer));

			foreach(Customer c in customers)
			{
				Console.WriteLine(c.Name + " orders :");
				foreach(Order o in c.Orders)
				{
					Console.WriteLine(o.Quantity + " " + o.ProductName);
				}
			}

			IList orders = pm.Load(typeof(Order));

			foreach(Order order in orders)
			{
				string product = order.ProductName;
				string owner = order.Parents.GetCustomer().Name;
				
				Console.WriteLine(product + " belongs to: " + owner);
			}
		}
	}
}
