using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;


namespace EntityDiscriminatorMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			pe.InitializeRepository();

			Entity e1 = new Entity("Employee");
			e1.AddValue("LastName", "King");

			Entity e2 = new Entity("Employer");
			e2.AddValue("LastName", "Suyama");

			Entity e3 = new Entity("Employee");
			e3.AddValue("LastName", "Moore");

			Transaction t = new Transaction();
			t.Serialize(e1);
			t.Serialize(e2);
			t.Serialize(e3);
			pe.Commit(t);

			EntitySet employees = pe.Load("Employee", true);

			foreach(Entity employee in employees)
			{
				Console.WriteLine(employee.GetString("LastName"));
			}

			EntitySet employers = pe.Load("Employer", true);

			foreach(Entity employer in employers)
			{
				Console.WriteLine(employer.GetString("LastName"));
			}
		}
	}
}
