using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace InheritanceModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Inheritance example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Animal c = new Cat();
			c.Description = "Persian cat";
			c.LegsNumber = 4;

			Animal d = new Dog();
			d.Description = "Poodle";
			d.LegsNumber = 4;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c);
			pm.Serialize(d);
			pm.CommitTransaction();

			IList animals = pm.Load(typeof(Animal));

			foreach(Animal animal in animals)
			{
				Console.WriteLine(animal.LegsNumber + " legs animal:");
				Console.WriteLine(animal.Description);
			}
		}
	}
}
