using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace LinkClassModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Association class example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Company c1 = new Company();
			c1.Name = "Comrcio Mineiro";
			c1.Chairman = "Pedro Afonso";
			c1.Address = "Av. dos Lusadas, 23";
			c1.City = "Sao Paulo";

			Employee e1 = new Employee();
			e1.Name = "Accorti";
			e1.Firstname = "Paolo";
			e1.Birthday = new DateTime(1982, 06, 12);

			Employee e2 = new Employee();
			e2.Name = "Cruz";
			e2.Firstname = "Aria";
			e2.Birthday = new DateTime(1978, 10, 05);

			Job j1 = new Job();
			j1.Title = "Accountant";
			j1.StartDate = new DateTime(2003, 04, 01);

			Job j2 = new Job();
			j2.Title = "Worker";
			j2.StartDate = new DateTime(2003, 05, 03);

			j1.Employee = e1;
			j2.Employee = e2;

			c1.EmployeeJob.Add(j1);
			c1.EmployeeJob.Add(j2);

			pm.BeginTransaction();
			pm.Serialize(j1);
			pm.Serialize(j2);
			pm.CommitTransaction();

			IList jobs = pm.Load(typeof(Job));

			foreach(Job j in jobs)
			{
				string employeeName = j.Employee.Name;
				string jobName = j.Title;
				string companyName = j.Parents.GetCompanyEmployees().Name;
				Console.WriteLine(jobName + ":" + employeeName + " at " + companyName);
			}
		}
	}
}
