using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;

namespace ManyToManyMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();
			
			//Bug with InitializeRepository
			pe.InitializeRepository();

			Entity a1 = new Entity("Address");
			a1.AddValue("Street", "Cerrito 333");
			a1.AddValue("PostalCode", 1010);
			a1.AddValue("City", "Buenos Aires");

			Entity a2 = new Entity("Address");
			a2.AddValue("Street", "Hauptstr. 29");
			a2.AddValue("PostalCode", 3012);
			a2.AddValue("City", "Bern");

			Entity p1 = new Entity("Person");
			p1.AddValue("Name", "Saveley");
			p1.AddValue("FirstName", "Marc");
			p1.AddValue("Addresses", a1);
			p1.AddValue("Addresses", a2);

			Entity p2 = new Entity("Person");
			p2.AddValue("Name", "Ashworth");
			p2.AddValue("FirstName", "Victoria");
			p2.AddValue("Addresses", a1);

			Transaction t = new Transaction();
			t.Serialize(p1);
			t.Serialize(p2);
			pe.Commit(t);

			EntitySet persons = pe.Load("Person", true);

			foreach(Entity person in persons)
			{
				Console.WriteLine(person.GetString("Name"));

				pe.LoadReference(person, "Addresses", true);

				foreach(Entity address in person.GetEntitySet("Addresses"))
				{
					Console.WriteLine(address.GetString("City"));
				}
			}
		}
	}
}
