using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using ObjectModel;

namespace ObjectModelGeneration
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			PersistenceManagerFactory pmf = new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			//Person Serialisation
			Person p = new Person();
			p.Name = "Moos";

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();

			//Loading Persons
			IList persons = pm.Load(typeof(Person));
//			IList persons = pm.Load(typeof(Person), "[Name='Moos']");

			foreach(Person person in persons)
			{
				Console.WriteLine(person.Name);
			}

			//Persons updating
			IList personsToUpdate = pm.Load(typeof(Person));
			
			foreach(Person currentPerson in personsToUpdate)
			{
				currentPerson.Name = "new_name";

				pm.BeginTransaction();
				pm.Serialize(currentPerson);
				pm.CommitTransaction();
			}

			//Persons removing
			IList personsToRemove = pm.Load(typeof(Person));
			
			foreach(Person currentPerson in personsToUpdate)
			{
				Console.WriteLine(currentPerson.Name);

				pm.BeginTransaction();
				pm.Delete(currentPerson);
				pm.CommitTransaction();
			}
		}
	}
}
