using System;
using System.Collections;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;

using Demo;

namespace OneTablePerConcreteClassMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			pm.InitializeRepository();

			Bakery b = new Bakery();
			b.Name = "Mendel Bakery";
			b.SiretNb = 12;
			b.BakerySort = "Traditional cooking";

			CarFactory c = new CarFactory();
			c.Name = "CD Cars";
			c.SiretNb = 154;
			c.CarSort = "Sport cars";

			SoftwareEditor s = new SoftwareEditor();
			s.Name = "Ibsen Softs";
			s.SiretNb = 568;
			s.SoftwareSort = "Accounting";

			pm.BeginTransaction();
			pm.Serialize(b);
			pm.Serialize(c);
			pm.Serialize(s);
			pm.CommitTransaction();

			IList companies = pm.Load(typeof(Company));

			foreach(Company company in companies)
			{
				Console.WriteLine(company.Name);
			}
		}
	}
}
