using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;

namespace OneToManyMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();
			
			//Bug with InitializeRepository
			pe.InitializeRepository();

			Entity o1 = new Entity("Order");
			o1.AddValue("ProductName", "Coffee");

			Entity o2 = new Entity("Order");
			o2.AddValue("ProductName", "Chocolade");

			Entity o3 = new Entity("Order");
			o3.AddValue("ProductName", "Ipoh Coffee");

			Entity c1 = new Entity("Customer");
			c1.AddValue("ContactName", "Saveley");
			c1.AddValue("Orders", o1);
			c1.AddValue("Orders", o2);

			Entity c2 = new Entity("Customer");
			c2.AddValue("ContactName", "Ibsen");
			c2.AddValue("Orders", o3);
			
			Transaction t = new Transaction();
			t.Serialize(c1);
			t.Serialize(c2);
			pe.Commit(t);

			EntitySet customers = pe.Load("Customer", true);

			foreach(Entity customer in customers)
			{
				Console.WriteLine(customer.GetString("ContactName"));

				pe.LoadReference(customer, "Orders", true);

				EntitySet orders = customer.GetEntitySet("Orders");

				foreach(Entity order in orders)
				{
					Console.WriteLine(order.GetString("ProductName"));
				}
			}
		}
	}
}
