using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace SimpleClassModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Simple class example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Person p = new Person();
			p.Name = "Moos";
			p.Firstname = "Hanna";
			p.Birthday = new DateTime(1970, 10, 25);
			
			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();

			IList persons = pm.Load(typeof(Person));
			foreach(Person person in persons)
			{
				Console.WriteLine(person.Name + " " + person.Firstname);
			}
		}
	}
}
