using System;
using System.Collections;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;

using Demo;


namespace SimpleObjectMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			pm.InitializeRepository();

			Employee e = new Employee();
			e.LastName = "Dodsworth";
			
			pm.BeginTransaction();
			pm.Serialize(e);
			pm.CommitTransaction();

			IList employees = pm.Load(typeof(Employee));
			
			foreach(Employee employee in employees)
			{
				Console.WriteLine(employee.LastName);
			}
		}
	}
}
