using System;
using Evaluant.OPath.Expressions.Collections;

namespace Evaluant.OPath.Expressions
{
	/// <summary>
	/// Description rsume de Path.
	/// </summary>
	[Serializable]
    public class Path : Constraint, ICloneable
	{
		/// <summary>
		/// Creates a new <see cref="Path"/> instance.
		/// </summary>
		public Path() : base()
		{
			identifiers = new IdentifierCollection();
		}

        public Path(IdentifierCollection identifiers)
        {
            this.identifiers = identifiers;
        }

        [System.Diagnostics.DebuggerStepThrough]
        public override void Accept(OPathVisitor visitor)
		{
			visitor.Visit(this);
		}

		private IdentifierCollection identifiers;
		public IdentifierCollection Identifiers
		{
			get { return identifiers; }
		}

        public override void ToString(System.Text.StringBuilder sb)
        {
            for(int i=0; i<identifiers.Count; i++)
            {
                if (i > 0)
                {
                    sb.Append(".");
                }

                identifiers[i].ToString(sb);
            }
        }

		#region Membres de ICloneable

		public override object Clone()
		{
			Path clone = new Path();

			foreach(Identifier identifier in this.Identifiers)
				clone.Identifiers.Add((Identifier)identifier.Clone());

			return clone;
		}

		#endregion
	}
}
