using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.DomainModel.ClassModel
{
	/// <summary>
	/// Description rsume de Class.
	/// </summary>
	/// 
	[Serializable]
	public class Class
	{
		public Class() 
			: this(string.Empty)
		{

		}

		public Class(string name)
			: this(name, string.Empty, string.Empty)
		{
		}

		public Class(string name, string inherit)
			: this(name, inherit, string.Empty)
		{
		
		}

		public Class(string name, string inherit, string implement)
		{
			_Name = name;
			_Inherit = inherit;
			_Implement = implement;
			_Properties = new PropertyCollection();
		}

		private string _Namespace;
		public string Namespace
		{
			get { return _Namespace; }
			set { _Namespace = value; }
		}

		public string FullName
		{
			get
			{
				return String.Concat(_Namespace, ".", _Name);
			}
		}

		private string _Name;
		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get { return _Name; }
			set { _Name = value; }
		}

		private string _Implement;
		[XmlAttribute("implement", DataType="string")]
		public string Implement
		{
			get { return _Implement; }
			set { _Implement = value; }
		}

		private string _Inherit;
		[XmlAttribute("inherit", DataType="string")]
		public string Inherit
		{
			get { return _Inherit; }
			set { _Inherit= value; }
		}

		private PropertyCollection _Properties;
		[XmlElement("Property")]
		public PropertyCollection Properties
		{
			get { return _Properties; }
			set { _Properties = value; }
		}
	}
}
