using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

using Evaluant.Uss.SqlMapper;
using System.Text;

namespace Evaluant.Uss.DomainModel.OptionModel
{
	/// <summary>
	/// Description rsume de Entity.
	/// </summary>
	public class EntityOption
	{
		public EntityOption(string className, string tableName)
		{
			_className = className;
			_tableName = tableName;
			_discriminatorValue = className;
			_discriminatorField = String.Empty;
			_id = new IdOption();
            _id.FieldName = String.Concat(tableName, "Id");
        }

		public EntityOption(string className) : this(className, GetTableName(className))
		{

		}

		public EntityOption() : this(String.Empty, String.Empty)
		{
			_id = new IdOption();
		}

        public static string GetTableName(string className)
        {
            // Generic type ?
            if (className.Contains("{"))
            {
                int start = className.IndexOf("{");
                ArrayList parameterTypes = new ArrayList();
                StringBuilder currentType = new StringBuilder();;
                int level = 0;
                for (int i = start; i < className.Length; i++)
                {
                    char c = className[i];

                    if (c == '}')
                    {
                        level--;
                    }

                    if (level != 0)
                    {
                        currentType.Append(c);
                    }

                    if (c == '{')
                    {
                        level++;
                    }

                    if (level == 0)
                    {
                        parameterTypes.Add(GetTableName(currentType.ToString()));
                        currentType = new StringBuilder();
                    }
                }

                StringBuilder result = new StringBuilder();
                result.Append(GetTableName(className.Substring(0, start)));
                result.Append("Of");
                result.Append( String.Join("And", (string[])parameterTypes.ToArray(typeof(string))));
                
                return result.ToString();
            }
            else
            {
                return className.Substring(className.LastIndexOf(":") + 1);
            }
        }

		private string _className;
		[XmlAttribute("classname", DataType="string")]
		public string ClassName
		{
			get
			{
				return _className;
			}
			set
			{
				_className = value;
			}
		}

		private string _tableName;
		[XmlAttribute("tablename", DataType="string")]
		public string TableName
		{
			get
			{
				return _tableName;
			}
			set
			{
				_tableName = value;
			}
		}

		private string _discriminatorField;
		[XmlAttribute("discriminatorfield", DataType="string")]
		public string DiscriminatorField
		{
			get
			{
				return _discriminatorField;
			}
			set
			{
				_discriminatorField = value;
			}
		}

		private string _discriminatorValue;
		[XmlAttribute("discriminatorvalue", DataType="string")]
		public string DiscriminatorValue
		{
			get
			{
				return _discriminatorValue;
			}
			set
			{
				_discriminatorValue = value;
			}
		}

		private IdOption _id;
		[XmlElement]
		public IdOption Id
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}
	}
}
