using System;

using System.Xml;
using System.Xml.Serialization;

using Evaluant.Uss.Common;

namespace Evaluant.Uss.Models
{
	/// <summary>
	/// Description rsume de Attribute.
	/// </summary>
	/// 
	[Serializable]
	public class Attribute
	{
		private string _Name;
		private Type _Type;
		private string[] _Values = new string[0];

		public Attribute(string name, Type type)
		{
			_Name = name;
			_Type = type;
		}

		public Attribute() : this(String.Empty, typeof(object))
		{
		}

		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get	{ return _Name;	}
			set	{ _Name = value; }
		}

		[XmlAttribute("type", DataType="string")]
		public string TypeName
		{
			get 
			{ 
				return Common.Utils.GetFullName(_Type);	
			}
			set	
			{ 
				_Type = Utils.GetType(value); 
			}
		}

		[XmlAttribute("values")]
		public string[] Values
		{
			get { return _Values; }
			set { _Values = value; }
		}
        
		[XmlIgnore()]
		public Type Type
		{
			get { return _Type; }
			set { _Type = value; }
		}

	}
}
