using System;

using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.Models
{
	/// <summary>
	/// Description rsume de Reference.
	/// </summary>
	/// 
	[Serializable]
	public class Reference
	{
		private string _Name;
		private string _ParentType;
		private string _ChildType;
		private bool _IsComposition;
        private bool _FromMany;
        private bool _ToMany;

        private Reference()
        {
        }

        public Reference(string name, string parenttype, string childtype, bool isComposition, bool fromMany, bool toMany)
        {
            _Name = name;
            _ParentType = parenttype;
            _ChildType = childtype;
            _IsComposition = isComposition;
            _FromMany = fromMany;
            _ToMany = toMany;
        }

		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get	{ return _Name;	}
			set	{ _Name = value; }
		}

		[XmlAttribute("type", DataType="string")]
		public string ParentType
		{
			get { return _ParentType;	}
			set	{ _ParentType = value; }
		}

		[XmlAttribute("childtype", DataType="string")]
		public string ChildType
		{
			get { return _ChildType; }
			set { _ChildType = value; }
		}

        [XmlAttribute("composition")]
        public bool IsComposition
        {
            get { return _IsComposition; }
            set { _IsComposition = value; }
        }

        [XmlAttribute("fromMany")]
        public bool FromMany
        {
            get { return _FromMany; }
            set { _FromMany = value; }
        }

        [XmlAttribute("toMany")]
        public bool ToMany
        {
            get { return _ToMany; }
            set { _ToMany = value; }
        }

        public override string ToString()
        {
            return String.Concat(_ParentType, ", ", _ChildType, ", ", _Name);
        }
	}
}
