using System;
using System.Collections.Generic;
using System.Text;
using DslModeling = global::Microsoft.VisualStudio.Modeling;
using DslDesign = global::Microsoft.VisualStudio.Modeling.Design;

namespace Evaluant.EussDSL
{
    /// <summary>
    /// Redefinition of the constructor of the link between an Entity and it's Identifier : when the link is created,
    /// the attribute "childTable" is automatically filled.
    /// </summary>
    public partial class EntityHasIdentifiers : DslModeling::ElementLink
    {
        /// <summary>
        /// Constructor
        /// Creates a EntityHasIdentifier link in the same Partition as the given Entity
        /// </summary>
        /// <param name="source">Entity to use as the source of the relationship.</param>
        /// <param name="target">Identifier to use as the target of the relationship.</param>
        public EntityHasIdentifiers(Entity source, Identifier target)
            : base((source != null ? source.Partition : null), new DslModeling::RoleAssignment[] { new DslModeling::RoleAssignment(EntityHasIdentifiers.EntityDomainRoleId, source), new DslModeling::RoleAssignment(EntityHasIdentifiers.IdentifierDomainRoleId, target) }, null)
        {
            target.field = source.type + "Id";
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="store">Store where new link is to be created.</param>
        /// <param name="roleAssignments">List of relationship role assignments.</param>
        public EntityHasIdentifiers(DslModeling::Store store, params DslModeling::RoleAssignment[] roleAssignments)
            : base(store != null ? store.DefaultPartition : null, roleAssignments, null)
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="store">Store where new link is to be created.</param>
        /// <param name="roleAssignments">List of relationship role assignments.</param>
        /// <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        public EntityHasIdentifiers(DslModeling::Store store, DslModeling::RoleAssignment[] roleAssignments, DslModeling::PropertyAssignment[] propertyAssignments)
            : base(store != null ? store.DefaultPartition : null, roleAssignments, propertyAssignments)
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="partition">Partition where new link is to be created.</param>
        /// <param name="roleAssignments">List of relationship role assignments.</param>
        public EntityHasIdentifiers(DslModeling::Partition partition, params DslModeling::RoleAssignment[] roleAssignments)
            : base(partition, roleAssignments, null)
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="partition">Partition where new link is to be created.</param>
        /// <param name="roleAssignments">List of relationship role assignments.</param>
        /// <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        public EntityHasIdentifiers(DslModeling::Partition partition, DslModeling::RoleAssignment[] roleAssignments, DslModeling::PropertyAssignment[] propertyAssignments)
            : base(partition, roleAssignments, propertyAssignments)
        {
            try
            {
                ((Identifier)roleAssignments[1].RolePlayer).field = ((Entity)roleAssignments[0].RolePlayer).type + "Id";
            }
            catch
            {
                // TODO : que faire lors d'une erreur  ce niveau?
                // erreur inconnue : "field" prendra la valeur "Id" comme spcifi dans son constructeur
            }
        }
    }
}
