using System;
using System.Collections;
using System.Collections.Specialized;

using Evaluant.Uss.Models;
using Evaluant.Uss.MetaData;
using Evaluant.Uss.SqlMapper;
using Evaluant.Uss.DomainModel.OptionModel;
using Evaluant.Uss.MappingGenerator.TypeConverter;

using Microsoft.Win32;
using MappingGenerator;

namespace Evaluant.Uss.MappingGenerator
{
	/// <summary>
	/// Description rsume de MappingGenerator.
	/// </summary>
	public class MappingGenerator
	{
		public static Mapping BuildMapping(InheritanceStrategy strategy, Model model, Option option)
		{
			switch(strategy)
			{
				case InheritanceStrategy.TablePerHierarchy:
					return new TablePerHierarchy(model, option).CreateMapping();
				case InheritanceStrategy.TablePerSubClass:
                    return new TablePerSubClass(model, option).CreateMapping();
				case InheritanceStrategy.TablePerConcreteClass:
                    return new TablePerConcreteClass(model, option).CreateMapping();
				default:
					break;
			}

			return null;
		}
	}
}
