using System;
using System.Collections;

using System.Xml.Serialization;

namespace Evaluant.Uss.MappingGenerator.TypeConverter
{
	[Serializable]
	public class DataPropertyCollection : CollectionBase
	{

		public int Add(DataProperty value)
		{
			return base.List.Add(value as object);
		}

		public void Remove(DataProperty value)
		{
			base.List.Remove( (object)value);
		}

		public void Insert(int index, DataProperty value)
		{
			base.List.Insert(index, (object)value);
		}

		public bool Contains(DataProperty value)
		{
			return base.List.Contains( (object)value);
		}

		public DataProperty this[int index]
		{
			get { return ( (DataProperty)base.List[index]); }
		}

		public DataProperty GetDataProperty(string name)
		{
			foreach(DataProperty d in base.List)
				if(d.Name == name)
					return d;
			return null;
		}
	}
}
