using System;
using System.Collections;

using Microsoft.VisualStudio.TestTools.UnitTesting;
using Evaluant.Uss;
using Evaluant.Uss.MetaData;
using Evaluant.Uss.ObjectContext;
using Evaluant.Uss.ObjectContext.Descriptors;


namespace NUnit.DynamicProxy
{
    /// <summary>
    /// Description rsume de Proxy.
    /// </summary>
    [TestClass]
    public class ProxyMetaData1
    {
        IPersistenceProvider provider;
        public ObjectService os;
        public Evaluant.Uss.ObjectContext.ObjectContext pm;

        public ProxyMetaData1()
        {
            Console.WriteLine(Environment.CurrentDirectory);
            provider = XmlConfigLoader.LoadXmlConfig("engines.config", "Prevalence");
            Configure();
        }

        public void Configure()
        {
            ObjectService factory = new ObjectService("engines.config", "Xml");
            factory.AddAssembly("NUnit");

            factory.RegisterMetaData(MetaDataFactory.FromPropertyDescriptor(typeof(Person), factory.PersistentDescriptor, true));
            factory.RegisterMetaData(MetaDataFactory.FromPropertyDescriptor(typeof(Address), factory.PersistentDescriptor, true));
            factory.RegisterMetaData(MetaDataFactory.FromPropertyDescriptor(typeof(Country), factory.PersistentDescriptor, true));

            this.pm = factory.CreateObjectContext();
        }

        [TestMethod]
        public void EnsureMetadataAreCorrectlyRegistered()
        {

        }
    }
}
