using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using EUSSOverview;

using NUnit.Framework;

namespace UseCases.EUSSOverview
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		[Test]
		public void Main()
		{
			ObjectService pmf = new ObjectService("UseCases.config", "EUSSOverview");
			pmf.AddAssembly(typeof(Customer).Assembly);
			ObjectContext pm = pmf.CreateObjectContext();

			Customer c1 = new Customer();
			c1.Name = "Wang";
			c1.Firstname = "Yanf";
			c1.Address = "Hauptstr. 29";
			c1.City = "Berlin";

			Order o1 = new Order();
			o1.Quantity = 1;
			o1.ProductName = "Coffee";
			o1.Date = new DateTime(2005, 02, 20);
			o1.Amount = 11.5;

			Order o2 = new Order();
			o2.Quantity = 2;
			o2.ProductName = "Chocolade";
			o2.Date = new DateTime(2005, 09, 12);
			o2.Amount = 53.4;

			c1.Orders.Add(o1);
			c1.Orders.Add(o2);

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c1);
			pm.CommitTransaction();

			pm.Clear();

			IList customers = pm.Load(typeof(Customer), "[Name='Wang']");

			Assert.AreEqual(1, customers.Count);
			
		}
	}
}
