using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using Implementation;

using NUnit.Framework;

namespace UseCases.ImplementationModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void SetUp()
		{
			pmf = new ObjectService("UseCases.config", "ImplementationModel");
			pmf.AddAssembly(typeof(Film).Assembly);
			pm = pmf.CreateObjectContext();

			pm.InitializeRepository();

			Film f = new Film();
			f.Name="Holidays film (2005)";
			f.Description = "Family film";
			f.Author = "Robert King";

			Car c = new Car();
			c.Name = "Yellow car";
			c.Year = new DateTime(2003, 02, 01);
			c.Engine = "Diesel";

			pm.BeginTransaction();
			pm.Serialize(c);
			pm.Serialize(f);
			pm.CommitTransaction();
		}

		[Test]
		public void TestINameable()
		{
			pm.Clear();

			IList nameables = pm.Load(typeof(INameable));
			Assert.AreEqual(2, nameables.Count);
		}

		[Test]
		public void TestCars()
		{
			pm.Clear();

			IList cars = pm.Load(typeof(INameable), "[Name='Yellow car']");
			Assert.AreEqual(1, cars.Count);
			Car car = (Car)cars[0];
			Assert.AreEqual("Yellow car", car.Name);
		}
	}
}
