using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using Inheritance;

using NUnit.Framework;

namespace UseCases.InheritanceModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void SetUp()
		{
			pmf = new ObjectService("UseCases.config", "InheritanceModel");
			pmf.AddAssembly(typeof(Cat).Assembly);
			pm = pmf.CreateObjectContext();

			Animal c = new Cat();
			c.Description = "Persian cat";
			c.LegsNumber = 4;

			Animal d = new Dog();
			d.Description = "Poodle";
			d.LegsNumber = 4;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c);
			pm.Serialize(d);
			pm.CommitTransaction();
		}

		[Test]
		public void TestCat()
		{
			pm.Clear();

			IList cats = pm.Load(typeof(Cat), "[Description='Persian cat']");
			Assert.AreEqual(1, cats.Count);
			Cat cat = (Cat)cats[0];
			Assert.AreEqual("Persian cat", cat.Description);
		}

		[Test]
		public void TestDog()
		{
			pm.Clear();

			IList dogs = pm.Load(typeof(Dog), "[Description='Poodle']");
			Assert.AreEqual(1, dogs.Count);
			Dog dog = (Dog)dogs[0];
			Assert.AreEqual("Poodle", dog.Description);
		}
	}
}
