using System;
using System.Xml;
using System.Xml.Serialization;
using System.Reflection;
using System.Diagnostics.SymbolStore;

namespace Pdb.Model
{
	/// <summary>
	/// Description rsume de LocalModel.
	/// </summary>
	/// 
	[Serializable]
	public class Local
	{
		public Local()
		{

		}

		public Local(int index, int start, int end)
		{
			_index = index;
			_start = start;
			_end = end;
		}

		private byte[] _signature;
		[XmlElement("Signature")]
		public byte[] Signature
		{
			get
			{
				return _signature;
			}
			set
			{
				_signature = value;
			}
		}

		private string _name;
		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		private FieldAttributes _attributes;
		[XmlElement("Attribute")]
		public FieldAttributes Attributes
		{
			get
			{
				return _attributes;
			}
			set
			{
				_attributes = value;
			}
		}

		private SymAddressKind _addressKind;
		[XmlElement("AddressKind")]
		public SymAddressKind AddressKind
		{
			get
			{
				return _addressKind;
			}
			set
			{
				_addressKind = value;
			}
		}

		private int _addressField1;
		[XmlAttribute("address_field_1", DataType = "int")]
		public int AddressField1
		{
			get
			{
				return _addressField1;
			}
			set
			{
				_addressField1 = value;
			}
		}

		private int _addressField2;
		[XmlAttribute("address_field_2", DataType = "int")]
		public int AddressField2
		{
			get
			{
				return _addressField2;
			}
			set
			{
				_addressField2 = value;
			}
		}

		private int _addressField3;
		[XmlAttribute("address_field_3", DataType = "int")]
		public int AddressField3
		{
			get
			{
				return _addressField3;
			}
			set
			{
				_addressField3 = value;
			}
		}

		private int _index;
		[XmlAttribute("il_index", DataType="int")]
		public int Index
		{
			get
			{
				return _index;
			}
			set
			{
				_index = value;
			}
		}

		private int _start;
		[XmlAttribute("il_start", DataType="int")]
		public int Start
		{
			get
			{
				return _start;
			}
			set
			{
				_start = value;
			}
		}

		private int _end;
		[XmlAttribute("il_end", DataType="int")]
		public int End
		{
			get
			{
				return _end;
			}
			set
			{
				_end = value;
			}
		}
	}
}
