using System;
using System.Xml;
using System.Xml.Serialization;

using System.Collections;

using System.Diagnostics.SymbolStore;

namespace Pdb.Model
{
	/// <summary>
	/// Description rsume de MethodModel.
	/// </summary>
	/// 
	[Serializable]
	public class Method
	{
		public Method()
		{
			_sequencePoints = new EntryCollection();
			_locals = new LocalCollection();
		}

//		private ISymbolScope _rootScope;
//		public ISymbolScope RootScope
//		{
//			get
//			{
//				return _rootScope;
//			}
//			set
//			{
//				_rootScope = value;
//			}
//		}

		private string _typeName;
		[XmlAttribute("typeName", DataType="string")]
		public string TypeName
		{
			get
			{
				return _typeName;
			}
			set
			{
				_typeName = value;
			}
		}

		private string _namespace;
		[XmlAttribute("namespace", DataType="string")]
		public string Namespace
		{
			get
			{
				return _namespace;
			}
			set
			{
				_namespace = value;
			}
		}

		private int _startScope;
		[XmlAttribute("startScope", DataType="int")]
		public int StartScope
		{
			get
			{
				return _startScope;
			}
			set
			{
				_startScope = value;
			}
		}

		private int _endScope;
		[XmlAttribute("endScope", DataType="int")]
		public int EndScope
		{
			get
			{
				return _endScope;
			}
			set
			{
				_endScope = value;
			}
		}

		private string _name;
		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		private string _fullName;
		[XmlAttribute("fullname", DataType="string")]
		public string FullName
		{
			get
			{
				return _fullName;
			}
			set
			{
				_fullName = value;
			}
		}

		private int _token;
		[XmlAttribute("token", DataType="int")]
		public int Token
		{
			get
			{
				return _token;
			}
			set
			{
				_token= value;
			}
		}

		private EntryCollection _sequencePoints;
		[XmlElement("SequencePoint")]
		public EntryCollection SequencePoints
		{
			get
			{
				return _sequencePoints;
			}
			set
			{
				_sequencePoints= value;
			}
		}

		private LocalCollection _locals;
		[XmlElement("Local")]
		public LocalCollection Locals
		{
			get
			{
				return _locals;
			}
			set
			{
				_locals= value;
			}
		}
	}
}
