using System;
using System.Collections;

using Pdb.Model;
using System.Xml.Serialization;

namespace Pdb.Model
{
	[Serializable]
	public class MethodCollection : CollectionBase
	{

		public int Add(Method value)
		{
			return base.List.Add(value as object);
		}

		public void Remove(Method value)
		{
			base.List.Remove( (object)value);
		}

		public void Insert(int index, Method value)
		{
			base.List.Insert(index, (object)value);
		}

		public bool Contains(Method value)
		{
			return base.List.Contains( (object)value);
		}

		public Method this[int index]
		{
			get { return ( (Method)base.List[index]); }
		}

		public Method GetMethodByFullName(string fullname)
		{
			foreach(Method method in base.List)
				if(method.FullName == fullname)
					return method;
			return null;
		}
	}
}
