using System;
using System.Xml;
using System.Xml.Serialization;

namespace Pdb.Model
{
	/// <summary>
	/// Description rsume de SymbolModel.
	/// </summary>
	/// 
	[XmlRoot]
	[Serializable]
	public class PdbInfos
	{
		public PdbInfos(string assemblyName)
		{
			_assemblyName = assemblyName;
			_methods = new MethodCollection();
			_files = new FileCollection();
			_entryPoint = new EntryPoint();
		}

		public PdbInfos() : this(String.Empty)
		{

		}

		private string _assemblyName;
		[XmlAttribute("assembly", DataType="string")]
		public string AssemblyName
		{
			get
			{
				return _assemblyName;
			}
			set
			{
				_assemblyName = value;
			}
		}

		private EntryPoint _entryPoint;
		[XmlElement("EntryPoint")]
		public EntryPoint EntryPoint
		{
			get
			{
				return _entryPoint;
			}
			set
			{
				_entryPoint= value;
			}
		}

		private FileCollection _files;
		[XmlElement("Files")]
		public FileCollection Files
		{
			get
			{
				return _files;
			}
			set
			{
				_files= value;
			}
		}

		private MethodCollection _methods;
		[XmlElement("Methods")]
		public MethodCollection Methods
		{
			get
			{
				return _methods;
			}
			set
			{
				_methods = value;
			}
		}
	}
}
