using System;
using System.Collections;
using System.Runtime.InteropServices;
using CustomToolGenerator;
using System.Xml;
using System.Xml.Xsl;
using System.IO;
using System.Text.RegularExpressions;
using System.Text;
using System.Reflection;
using EnvDTE;

using Evaluant.Uss.Xmi;
using layerGen = Evaluant.Uss.PersistenceLayerGen;

namespace PersistenceManager
{

	/// <summary>
	/// Description rsume de Class1.
	/// </summary>
	[Guid("AA3D9F98-EB4D-4ebb-9B09-C274D8CB1E5B")]
	public class PersistenceManagerGenerator : BaseCodeGeneratorWithSite
	{

		protected override byte[] GenerateCode(string file, string contents)
		{
            try
            {
                layerGen.PersistenceLayerGen.ProgrammingLangEnum progLang = GetDefaultExtension().EndsWith("cs") ? layerGen.PersistenceLayerGen.ProgrammingLangEnum.CSharp : layerGen.PersistenceLayerGen.ProgrammingLangEnum.VBnet;
                layerGen.PersistenceLayerGen generator = new layerGen.PersistenceLayerGen(file, progLang);

                using (StreamReader fileReader = new StreamReader(file))
                {
                    string result = generator.GenerateCode(file, fileReader.ReadToEnd());
                    return System.Text.Encoding.ASCII.GetBytes(result);
                }
            }
            catch (Exception e)
            {
                ErrorConsole(e.ToString());
                return System.Text.Encoding.ASCII.GetBytes("");
            }
		}

		public  byte[] GenerateCode2(string file, string contents)
		{
			return(this.GenerateCode(file,contents));
		}

		public static void ErrorConsole(string e)
		{
			EnvDTE.DTE dte = (EnvDTE.DTE)System.Runtime.InteropServices.Marshal.GetActiveObject("VisualStudio.DTE"); 
				
			Window wind = dte.Application.Windows.Item(Constants.vsext_wk_OutputWindow);
			wind.Activate();
			wind.Visible = true;

			OutputWindow outputWnd = (OutputWindow)wind.Object;

			OutputWindowPane genPane = outputWnd.ActivePane;

			if (genPane == null)
				outputWnd.OutputWindowPanes.Add("Generation");

			genPane.OutputString("An error occured during the generation:\n" + e);
			genPane.Activate();
		}
	}
}
