using System;
using System.Collections;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;


namespace AttributeDiscriminatorMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();
			
			pe.InitializeRepository();

			Entity p1 = new Entity("Person");
			p1.AddValue("City", "Berlin");
			p1.AddValue("LastName", "Anders");
			p1.AddValue("FirstName", "Martin");
			p1.AddValue("NickName", "AM");

			Entity p2 = new Entity("Person");
			p2.AddValue("City", "London");
			p2.AddValue("LastName", "Berglund");
			p2.AddValue("FirstName", "Hanna");
			p2.AddValue("NickName", "BH");

			Entity p3 = new Entity("Person");
			p3.AddValue("City", "Madrid");
			p3.AddValue("LastName", "Dodsworth");
			p3.AddValue("FirstName", "Thomas");
			p3.AddValue("NickName", "DT");

			Transaction t = new Transaction();
			t.Serialize(p1);
			t.Serialize(p2);
			t.Serialize(p3);
			pe.Commit(t);

			EntitySet persons = pe.Load("Person", true);

			foreach(Entity person in persons)
			{
				Console.WriteLine("New Person: ");

				Console.WriteLine("LastName: " + person.GetValue("LastName"));
				Console.WriteLine("FirstName: " + person.GetValue("FirstName"));
				Console.WriteLine("NickName : " + person.GetValue("NickName"));
				Console.WriteLine("City : " + person.GetValue("City"));
			}
		}
	}
}
