using System;
using UniversalStorageServices;


namespace AttributesLoading
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			Entity e = new Entity("Customer");
			e.AddValue("Name", "Ottlieb");
			e.AddValue("FirstName", "Sven");

			pe.InitializeRepository();

			Transaction t = new Transaction();
			t.Serialize(e);
			pe.Commit(t);

			//Loading all attributes in the same time as the parent
			EntitySet es1 = pe.Load("Customer", true);
			
			foreach(Entity currentCustomer in es1)
			{
				string name = currentCustomer.GetString("Name");
				string firstname = currentCustomer.GetString("FirstName");
				Console.WriteLine(name + " " + firstname);
			}

			//Just in time attributes loading (only the Name attribute)

			EntitySet es2 = pe.Load("Customer", false);
			
			foreach(Entity currentCustomer in es2)
			{
				pe.LoadAttribute(currentCustomer, "Name");
				pe.LoadAttribute(currentCustomer, "FirstName");

				string name = currentCustomer.GetString("Name");
				string firstname = currentCustomer.GetString("FirstName");

				Console.WriteLine(name + " " + firstname);
			}
		}
	}
}
