using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace EnumerationModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Enumeration example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Person p = new Person();
			p.Name = "Dodsworth";
			p.Firstname = "John";
			p.Birthday = new DateTime(1970, 01, 10);

			p.Title = Titles.Mr;

			pm.InitializeRepository();
			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();

			IList persons = pm.Load(typeof(Person));
			
			foreach(Person person in persons)
			{
				Console.WriteLine(person.Title + " " + person.Name);
			}
		}
	}
}
