using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace ImplementationModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Implementation example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Film f = new Film();
			f.Name="Holidays film (2005)";
			f.Description = "Family film";
			f.Author = "Robert King";

			Car c = new Car();
			c.Name = "Yellow car";
			c.Year = new DateTime(2003, 02, 01);
			c.Engine = "Diesel";

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c);
			pm.Serialize(f);
			pm.CommitTransaction();

			IList nameables = pm.Load(typeof(INameable));

			foreach(INameable n in nameables)
			{
				Console.WriteLine(n.Name);
			}
		}
	}
}
