using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace ManyToOneModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== Many-to-One association example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Company c1 = new Company();
			c1.Name = "Around the Horn";
			c1.Chairman = "Thomas Hardy";
			c1.Address = "120 Hanover Sq.";
			c1.City = "London";

			Company c2 = new Company();
			c2.Name = "B's Beverages";
			c2.Chairman = "Victoria Ashworth";
			c2.Address = "Fauntleroy Circus";
			c2.City = "London";

			CountableCabinet cb = new CountableCabinet();
			cb.Name = "Tom Mendel";
			cb.City = "London";

			c1.CountableCabinet = cb;
			c2.CountableCabinet = cb;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c1);
			pm.Serialize(c2);
			pm.CommitTransaction();

			IList companies = pm.Load(typeof(Company));

			foreach(Company company in companies)
			{
				Console.WriteLine(company.Name);
				Console.WriteLine(company.CountableCabinet.Name);
			}

			IList coutablecabinets = pm.Load(typeof(CountableCabinet));

			foreach(CountableCabinet coutablecabinet in coutablecabinets)
			{
				Console.WriteLine(coutablecabinet.Name + " manages these Companies:");
				foreach(Company company in coutablecabinet.Parents.GetCompanies())
				{
					Console.WriteLine(company.Name);
				}
			}
		}
	}
}
