using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using ObjectModel;

namespace OPath
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
//			GetDataFromDB();
//			PersistenceEngineRequestsAllPersons();
//			PersistenceManagerRequestsAllPersons();
//			PersistenceManagerRequestsSpecificPersons();
			PersistenceManagerRequestsPersonPartners();
		}

		public static void PersistenceManagerRequests()
		{
		
		}

		public static void PersistenceEngineRequestsAllPersons()
		{
			IPersistenceEngineFactory pef = XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config", "Xml");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			string opath = "Person";

			EntitySet es = pe.Load(opath, true);

			foreach(Entity e in es)
			{
				Console.WriteLine(e.GetValue("Name"));
			}
		}

		public static void PersistenceManagerRequestsAllPersons()
		{
			PersistenceManagerFactory pmf = new PersistenceManagerFactory("..\\..\\engines.config", "Xml");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Query q = new Query(typeof(Person));
			IList persons = pm.Load(q);

			foreach(Person p in persons)
			{
				Console.WriteLine("Person: " + p.Name);
			}

			
		}

		public static void PersistenceManagerRequestsSpecificPersons()
		{
			PersistenceManagerFactory pmf = new PersistenceManagerFactory("..\\..\\engines.config", "Xml");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Query q = new Query(typeof(Person), "Name='Steel' or Name='Latimer'");
			IList persons = pm.Load(q);

			foreach(Person p in persons)
			{
				Console.WriteLine("Person: " + p.Name);
			}			
		}

		public static void PersistenceManagerRequestsPersonPartners()
		{
			PersistenceManagerFactory pmf = new PersistenceManagerFactory("..\\..\\engines.config", "Xml");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			IList persons = pm.Load(typeof(Person));

			foreach(Person p in persons)
			{
				IList partners = p.Partners;
			}			
		}

		public static void PersistenceEngineRequestsSpecificsPersons()
		{
			IPersistenceEngineFactory pef = XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config", "Xml");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			string opath = "Person";

			EntitySet es = pe.Load(opath, true);

			foreach(Entity e in es)
			{
				Console.WriteLine(e.GetValue("Name"));
			}
		}

		public static void GetDataFromDB()
		{
			IPersistenceEngineFactory pefSource = XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config", "SqlServer");
			IPersistenceEngine peSource = pefSource.CreatePersistenceEngine();

			IPersistenceEngineFactory pefDest = XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config", "Xml");
			IPersistenceEngine peDest = pefDest.CreatePersistenceEngine();

			peDest.InitializeRepository();

			EntitySet esSource = peSource.Load("Customer", true);

			EntitySet esDest = new EntitySet();

			int count = 0;

			foreach(Entity e in esSource)
			{
				string fullname = e.GetString("ContactName");
				string name = fullname.Split(new char[]{' '})[1];
				string firstname = fullname.Split(new char[]{' '})[0];

				Entity partner = new Entity("ObjectModel:Person");
				partner.AddValue("Name", "PName" + count.ToString());
				partner.AddValue("FirstName", "PFirstName" + count.ToString());

				Entity tmp = new Entity("ObjectModel:Person");
				tmp.AddValue("Name", name);
				tmp.AddValue("FirstName", firstname);
				tmp.AddValue("Partners", partner);

				esDest.Add(tmp);
				count++;
			}

			Transaction t = new Transaction();
			t.Serialize(esDest);
			peDest.Commit(t);
		}

	}
}
