using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace OneToManyModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== One-to-Many association example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Customer c = new Customer();
			c.Name = "Wang";
			c.Firstname = "Yang";
			c.Address = "Hauptstr. 29";
			c.City = "Berlin";

			Order o1 = new Order();
			o1.ProductName = "Coffe";
			o1.Amount = 11.5;

			Order o2 = new Order();
			o2.ProductName = "Chocolade";
			o2.Amount = 53.4;

			c.Orders.Add(o1);
			c.Orders.Add(o2);

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c);
			pm.CommitTransaction();

			IList customers = pm.Load(typeof(Customer));

			foreach(Customer customer in customers)
			{
				Console.WriteLine(customer.Name + " ordered:");
				foreach(Order o in customer.Orders)
				{
					Console.WriteLine(o.ProductName);
				}
			}

			IList orders = pm.Load(typeof(Order));

			foreach(Order order in orders)
			{
				Console.WriteLine(order.ProductName + " belongs to:");
				
				Console.WriteLine(order.Parents.GetCustomer().Name);
			}
		}
	}
}
