using System;
using System.Collections;
using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;
using Example;



namespace OneToOneModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			Console.WriteLine();
			Console.WriteLine("===== One-to-One association example =====");

			PersistenceManagerFactory pmf = 
				new PersistenceManagerFactory("..\\..\\engines.config");
			PersistenceManager pm = pmf.CreatePersistenceManager();

			Person p = new Person();
			p.Name = "Accorti";
			p.Firstname = "Paolo";
			p.Birthday = new DateTime(1970, 05, 23);

			Job j = new Job();
			j.Title = "Accountant";
			j.StartDate = new DateTime(2000, 01, 01);

			p.Job = j;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();

			IList persons = pm.Load(typeof(Person));

			foreach(Person person in persons)
			{
				Console.WriteLine(person.Name + " works as :");
				Console.WriteLine(person.Job.Title);
			}

			IList jobs = pm.Load(typeof(Job));

			foreach(Job job in jobs)
			{
				Console.WriteLine(job.Title + " :");
				Console.WriteLine(job.Parents.GetPerson().Name);
				Console.WriteLine("");
			}
		}
	}
}
