using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;


namespace SimpleEntityMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			pe.InitializeRepository();

			Entity e = new Entity("Person");
			e.AddValue("LastName", "Dodsworth");

			Transaction t = new Transaction();
			t.Serialize(e);
			pe.Commit(t);

			EntitySet persons = pe.Load("Person", true);

			foreach(Entity person in persons)
			{
				Console.WriteLine(person.GetString("LastName"));
			}
		}
	}
}
