using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;


namespace UserDefinedIdMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	public class Program
	{
		[STAThread]
		public static void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("..\\..\\engines.config");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();

			pe.InitializeRepository();

			Entity e1 = new Entity("Person");
			e1.AddValue("LastName", "Berglund");
			e1.Id = "P001";

			Entity e2 = new Entity("Person");
			e2.AddValue("LastName", "Anders");
			e2.Id = "P002";

			Transaction t = new Transaction();
			t.Serialize(e1);
			t.Serialize(e2);
			pe.Commit(t);

			EntitySet persons = pe.Load("Person", true);

			foreach(Entity person in persons)
			{
				Console.WriteLine(person.GetString("LastName") + " id = " + person.Id);
			}
		}
	}
}
