using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Weblog.Services;
using Weblog.Domain;

namespace Weblog
{
	public class Default : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList DataListCategories;
		protected System.Web.UI.WebControls.DataList DataListPosts;
		protected System.Web.UI.WebControls.Calendar Calendar1;
		protected System.Web.UI.WebControls.Label LabelNoArticles;

		protected Blog blog = null;
		protected IService service = Global.CreateService();

		private void Page_Load(object sender, System.EventArgs e)
		{

			if(Request["title"] != null)
				blog = service.GetBlogWithTitle(Request["title"].ToString());
			else
				Response.Redirect("~/blogList.aspx");

			if(!Page.IsPostBack)
			{
				DataListPosts.DataSource = service.GetPostsFromBlog(blog);
				DataListCategories.DataSource = blog.Categories;

				Page.DataBind();

				LabelNoArticles.Visible = DataListPosts.Items.Count == 0;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: Cet appel est requis par le Concepteur Web Form ASP.NET.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Calendar1.SelectionChanged += new System.EventHandler(this.Calendar1_SelectionChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Calendar1_SelectionChanged(object sender, System.EventArgs e)
		{
			DataListPosts.DataSource = service.GetPostsFromBlogWithPublished(blog, Calendar1.SelectedDate); 
			DataListPosts.DataBind();

			LabelNoArticles.Visible = DataListPosts.Items.Count == 0;
		}
	}
}
