using System;
using System.Xml.Serialization;
using System.Text;
namespace Evaluant.OPath.Expressions
{
	/// <summary>
	/// Description rsume de Path.
	/// </summary>
	[Serializable]
	[XmlInclude(typeof(Value)), XmlInclude(typeof(Path)), XmlInclude(typeof(Expression))]
    public abstract class Constraint : IOPathElement
	{
		/// <summary>
		/// Creates a new <see cref="Constraint"/> instance.
		/// </summary>
		public Constraint() : base()
		{
		}

        [System.Diagnostics.DebuggerStepThrough]
        public virtual void Accept(OPathVisitor visitor)
		{
			visitor.Visit(this);
		}

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            ToString(sb);

            return sb.ToString();
        }

        public abstract void ToString(StringBuilder sb);

		#region Membres de ICloneable

		public abstract object Clone();

		#endregion
	}
}
