using System.Collections;
//using Evaluant.Uss.Common;
using Evaluant.Uss.MetaData;
using System.Threading;
using System.Diagnostics;
using Evaluant.Uss.PersistenceEngine.Contracts;

namespace Evaluant.Uss.Cache
{
	/// <summary>
	/// Description rsume de CacheProvider.
	/// </summary>
	public class CacheProvider : PersistenceEngineFactoryImplementation
	{
        internal static string CATEGORY = "Euss";
        internal static string NAME = "Cached Queries";

        private IdentityMap _Entities;
        private Hashtable _Scalars;
        private Hashtable _Loads;
        private ReaderWriterLock _RWL;

        public CacheProvider() : base()
		{
            //if (!PerformanceCounterCategory.Exists(CATEGORY))
            //{
            //    PerformanceCounterCategory.Create(CATEGORY, "Contains counters for Euss", NAME, "Number of Cached Queries");
            //}
		}

		public override void InitializeConfiguration()
		{
            _Entities = new IdentityMap();
            _Scalars = new Hashtable();
            _Loads = new Hashtable();
            _RWL = new ReaderWriterLock();
		}

		public override IPersistenceEngine CreatePersistenceEngine()
		{
			return new CacheEngine(_Delegator.CreatePersistenceEngine(), _Entities, _Scalars, _Loads, _RWL);
		}

		public override void RegisterMetaData(IMetaData[] metadata)
		{
			base.RegisterMetaData(metadata);
			_Delegator.RegisterMetaData(metadata);
		}

		private IPersistenceProvider _Delegator;
		public IPersistenceProvider Delegator
		{
			get { return _Delegator; }
			set { _Delegator = value;}
		}
	}
}
