using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.DomainModel.ClassModel
{
	/// <summary>
	/// Description rsume de Interface.
	/// </summary>
	/// 
	[Serializable]
	public class Interface
	{
		public Interface()
			: this(string.Empty)
		{
			
		}

		public Interface(string name)
		{
            _Name = name;			
		}

		private string _Name;
		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get { return _Name; }
			set { _Name = value; }
		}

		private string _Namespace;
		public string Namespace
		{
			get { return _Namespace; }
			set { _Namespace = value; }
		}

		public string FullName
		{
			get
			{
				return String.Concat(_Namespace, ".", _Name);
			}
		}


		private PropertyCollection _Properties;
		[XmlElement("Property")]
		public PropertyCollection Properties
		{
			get
			{
				return _Properties;
			}
			set
			{
				_Properties = value;
			}
		}
	}
}
