using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.DomainModel.ClassModel
{
	/// <summary>
	/// Description rsume de Package.
	/// </summary>
	/// 
	[Serializable]
	public class Package
	{
		public Package(string name)
		{
			_name = name;
			_Classes = new ClassCollection();
			_Interfaces = new InterfaceCollection();
			_Enums = new EnumerationCollection();
			_Relationships = new RelationshipCollection();
		}

		public Package() : this(String.Empty)
		{
			_Classes = new ClassCollection();
			_Interfaces = new InterfaceCollection();
			_Enums = new EnumerationCollection();
			_Relationships = new RelationshipCollection();
		}

		public Class GetParent(Class type)
		{
			foreach(Class c in _Classes)
				if(type.Inherit == c.FullName)
					return c;
			return null;
		}

		private string _name;
		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		private InterfaceCollection _Interfaces;
		[XmlElement("Interface")]
		public InterfaceCollection Interfaces
		{
			get { return _Interfaces; }
			set { _Interfaces = value; }
		}

		private ClassCollection _Classes;
		[XmlElement("Class")]
		public ClassCollection Classes
		{
			get
			{
				return _Classes;
			}
			set
			{
				_Classes = value;
			}
		}

		private EnumerationCollection _Enums;
		[XmlElement("Enumeration")]
		public EnumerationCollection Enums
		{
			get
			{
				return _Enums;
			}
			set
			{
				_Enums = value;
			}
		}

		private RelationshipCollection _Relationships;
		[XmlElement("Relationship")]
		public RelationshipCollection Relationships
		{
			get
			{
				return _Relationships;
			}
			set
			{
				_Relationships = value;
			}
		}
	}
}
