using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.DomainModel.ClassModel
{
	/// <summary>
	/// Description rsume de Relationship.
	/// </summary>
	/// 
	[Serializable]
	public class Relationship
	{
		public Relationship(string type)
		{
			_type = type;
		}

		public Relationship() : this(String.Empty)
		{
		
		}

		private string _type;
		[XmlAttribute("type", DataType="string")]
		public string Type
		{
			get
			{
				return _type;
			}
			set
			{
				_type = value;
			}
		}

		private Parent _parent;
		[XmlElementAttribute]
		public Parent Parent
		{
			get
			{
				return _parent;
			}
			set
			{
				_parent = value;
			}
		}

		private Child _child;
		[XmlElementAttribute]
		public Child Child
		{
			get
			{
				return _child;
			}
			set
			{
				_child = value;
			}
		}

		private LinkClass _linkClass;
		[XmlElementAttribute]
		public LinkClass LinkClass
		{
			get
			{
				return _linkClass;
			}
			set
			{
				_linkClass = value;
			}
		}
	}
}
