using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;
using Evaluant.Uss.DomainModel.ClassModel;

namespace Evaluant.Uss.DomainModel.OptionModel
{
	public enum InheritanceStrategy
	{
		TablePerHierarchy,
		TablePerSubClass,
		TablePerConcreteClass
	}

	/// <summary>
	/// Description rsume de Option.
	/// </summary>
	[XmlRoot]
	public class Option
	{

		public Option()
		{
			_EntityOptions = new EntityOptionCollection();
		}

		private InheritanceStrategy _strategy;

		[XmlElement]
		public InheritanceStrategy Strategy
		{
			get
			{
				return _strategy;
			}
			set
			{
				_strategy = value;
			}
		}

        private string _mappingFileName;
        [XmlElement]
        public string MappingFile
        {
            get
            {
                return _mappingFileName;
            }
            set
            {
                _mappingFileName = value;
            }
        }

        private bool _constraint;
        [XmlElement]
        public bool Constraint
        {
            get
            {
                return _constraint;
            }
            set
            {
                _constraint = value;
            }
        }

        private MetadataCollection _metadata = new MetadataCollection();
		
        [XmlElement("Metadata")]
		public MetadataCollection Metadata
		{
			get
			{
				return _metadata;
			}
			set
			{
				_metadata = value;
			}
		}

		private EntityOptionCollection _EntityOptions;
		[XmlElement("Entity")]
		public EntityOptionCollection EntityOptions
		{
			get
			{
				return _EntityOptions;
			}
			set
			{
				_EntityOptions = value;
			}
		}
    }
}
