using Evaluant.Uss.MetaData;
using System.Globalization;

namespace Evaluant.Uss.Hub
{
	/// <summary>
	/// Description rsume de HubProvider.
	/// </summary>
	public class HubProvider : IPersistenceProvider
	{
		public HubProvider()
		{
		}

		#region Membres de IPersistenceProvider

		public void InitializeConfiguration()
		{
		}

		public virtual IPersistenceEngine CreatePersistenceEngine()
		{
			IPersistenceEngine[] delegators = new IPersistenceEngine[_Delegators.Length];
			for(int i=0; i<_Delegators.Length; i++)
				delegators[i] = _Delegators[i].CreatePersistenceEngine();

			HubEngine engine = new HubEngine(delegators);
			engine.DefaultEngineIndex = _DefaultEngineIndex;

			return engine;
		}

		#endregion

		private IPersistenceProvider[] _Delegators;
		public IPersistenceProvider[] Delegators
		{
			get { return _Delegators; }
			set	{ _Delegators = value; }
		}

		private int _DefaultEngineIndex = 0;
		/// <summary>
		/// Gets or set the index of the engine used for reading
		/// </summary>
		public int DefaultEngineIndex
		{
			get { return _DefaultEngineIndex; }
			set { _DefaultEngineIndex = value; }
		}

		public void RegisterMetaData(IMetaData[] metadata)
		{
			foreach(IPersistenceProvider delegator in _Delegators)
			delegator.RegisterMetaData(metadata);
		}

		// Nothing to do as the culture must be specified in the last engine
		public CultureInfo Culture
		{
			get { return null;}
			set { }
		}
	}
}
