using System;
using System.Collections;
using System.IO;

using Evaluant.Uss.Commands;
using Evaluant.Uss.Models;

namespace Evaluant.Uss.Remoting
{
    /// <summary>
    /// Simple Delegate Engine implementation to show the interception capabilities of the framework
    /// </summary>
    public class RemoteController : MarshalByRefObject
    {
        private IPersistenceEngine _Delegator;

        public RemoteController()
        {
#if DEBUG
            _Delegator = XmlConfigLoader.LoadXmlConfig("..\\..\\test.engines.config").CreatePersistenceEngine();
#else
			_Delegator = XmlConfigLoader.LoadXmlConfig("engines.config").CreatePersistenceEngine();
#endif
            System.Diagnostics.Trace.WriteLine("Persistence engine : " + _Delegator.ToString());
        }

        //		public RemoteController(string configFileName)
        //		{
        //			if(!File.Exists(configFileName))
        //				throw new PersistenceEngineException("Configuration file was not found to init the server:\n" + configFileName);
        //
        //		}

        public override object InitializeLifetimeService()
        {
            return null;
        }

        public EntitySet Load(string opath)
        {
            return _Delegator.Load(opath);
        }

        public EntitySet Load(string opath, string[] attributes)
        {
            return _Delegator.Load(opath, attributes);
        }

        public EntitySet Load(string opath, string orderby, int first, int max)
        {
            return _Delegator.Load(opath, orderby, first, max);
        }

        public EntitySet Load(string opath, string[] attributes, string orderby, int first, int max)
        {
            return _Delegator.Load(opath, attributes, orderby, first, max);
        }

        public EntitySet Load(OPath.OPathQuery opath, string[] attributes, string orderby, int first, int max)
        {
            return _Delegator.Load(opath, attributes, orderby, first, max);
        }

        public Entity LoadWithId(string type, string id)
        {
            return _Delegator.LoadWithId(type, id);
        }

        public EntitySet LoadWithId(string type, string[] id)
        {
            return _Delegator.LoadWithId(type, id);
        }

        public EntitySet LoadWithId(string type, string[] id, string[] attributes)
        {
            return _Delegator.LoadWithId(type, id, attributes);
        }

        public void LoadReference(Entity entity)
        {
            _Delegator.LoadReference(entity);
        }

        public Entity LoadReference(Entity entity, string[] references)
        {
            _Delegator.LoadReference(entity, references);
            return entity;
        }

        public EntitySet LoadReference(System.Collections.IEnumerable entities)
        {
            _Delegator.LoadReference(entities);

            ArrayList al = new ArrayList();
            foreach (Entity e in entities)
            {
                al.Add(e);
            }
            return new EntitySet((Entity[])al.ToArray(typeof(Entity)));
        }

        public EntitySet LoadReference(System.Collections.IEnumerable entities, string[] references)
        {
            _Delegator.LoadReference(entities, references);

            ArrayList al = new ArrayList();
            foreach (Entity e in entities)
            {
                al.Add(e);
            }
            return new EntitySet((Entity[])al.ToArray(typeof(Entity)));
        }

        public object LoadScalar(string opath)
        {
            return _Delegator.LoadScalar(opath);
        }

        public object LoadScalar(OPath.OPathQuery opath)
        {
            return _Delegator.LoadScalar(opath);
        }

        public void InitializeRepository()
        {
            _Delegator.InitializeRepository();
        }

        public void Initialize()
        {
            _Delegator.Initialize();
        }

        public Transaction BeforeProcessCommands(Transaction tx)
        {
            _Delegator.BeforeProcessCommands(tx);
            return tx;
        }

        public Transaction ProcessCommands(Transaction tx)
        {
            _Delegator.ProcessCommands(tx);
            return tx;
        }

        public Transaction AfterProcessCommands(Transaction tx)
        {
            _Delegator.AfterProcessCommands(tx);
            return tx;
        }

        public Model Model
        {
            get
            {
                return _Delegator.Model;
            }
        }
    }
}
