using System.ComponentModel;
using System.Configuration.Install;
using System.ServiceProcess;

namespace UniversalPersistenceServices.Remoting
{
	/// <summary>
	/// Description rsume de HostServiceInstaller.
	/// </summary>
	[RunInstaller(true)]
	public class HostServiceInstaller : Installer
	{

		private ServiceInstaller HostInstaller;
		private ServiceProcessInstaller HostProcessInstaller;

		public HostServiceInstaller()
		{
			HostInstaller = new ServiceInstaller();
			HostInstaller.StartType = ServiceStartMode.Manual;
			HostInstaller.ServiceName = "RemoteControllerHost";
			HostInstaller.DisplayName = "Universal Storage Services Remote Controller Host";
			Installers.Add (HostInstaller); 
			HostProcessInstaller = new ServiceProcessInstaller();
			HostProcessInstaller.Account = ServiceAccount.User;
			Installers.Add (HostProcessInstaller);


		}
	}
}
