using Evaluant.Uss.MetaData;
using System.Globalization;
using System;

namespace Evaluant.Uss.Sync
{
	/// <summary>
	/// Description rsume de HubProvider.
	/// </summary>
	public class SyncProvider : IPersistenceProvider
	{

        public SyncProvider()
		{
		}

		#region Membres de IPersistenceProvider

		public void InitializeConfiguration()
		{
		}

		public IPersistenceEngine CreatePersistenceEngine()
		{
            return new SyncEngine(provider.CreatePersistenceEngine(), 
                metadataProvider.CreatePersistenceEngine(), 
                secondaryMetadataProvider !=  null ? secondaryMetadataProvider.CreatePersistenceEngine() : null,
                clientId);
		}

		#endregion

        private IPersistenceProvider provider;

        public IPersistenceProvider Provider
        {
            get { return provider; }
            set { provider = value; }
        }

        private IPersistenceProvider metadataProvider;

        public IPersistenceProvider MetadataProvider
        {
            get { return metadataProvider; }
            set { metadataProvider = value; }
        }

        private IPersistenceProvider secondaryMetadataProvider;

        public IPersistenceProvider SecondaryMetadataProvider
        {
            get { return secondaryMetadataProvider; }
            set { secondaryMetadataProvider = value; }
        }

        public void RegisterMetaData(IMetaData[] metadata)
		{
			provider.RegisterMetaData(metadata);
		}

        private string clientId = Guid.NewGuid().ToString();

        public string ClientId
        {
            get { return clientId; }
            set { clientId = value; }
        }

		// Nothing to do as the culture must be specified in the last engine
		public CultureInfo Culture
		{
			get { return null;}
			set { }
		}
	}
}
