using System;
using System.Collections;
using System.Xml;
using System.Xml.Serialization;

namespace Evaluant.Uss.Weave.PersistenceModel
{
	/// <summary>
	/// Description rsume de ClassModel.
	/// </summary>
	public class Class
	{
		private string _name;
		private Id _id;

		public Class() : this(String.Empty)
		{

		}

		public Class(string className)
		{
			_Relationships = new RelationshipCollection();
			_Fields = new FieldCollection();
			_Properties = new PropertyCollection();
		}

		[XmlAttribute("name", DataType="string")]
		public string Name
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		[XmlElementAttribute]
		public Id Id
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}

		private RelationshipCollection _Relationships;
		[XmlElement("Relationship")]
		public RelationshipCollection Relationships
		{
			get
			{
				return _Relationships;
			}
			set
			{
				_Relationships = value;
			}
		}

		private PropertyCollection _Properties;
		[XmlElement("Property")]
		public PropertyCollection Properties
		{
			get
			{
				return _Properties;
			}
			set
			{
				_Properties = value;
			}
		}

		private FieldCollection _Fields;
		[XmlElement("Field")]
		public FieldCollection Fields
		{
			get
			{
				return _Fields;
			}
			set
			{
				_Fields = value;
			}
		}
	}
}
