using System;
using System.Collections;

using System.Xml.Serialization;

namespace Evaluant.Uss.Weave.PersistenceModel
{
	[Serializable]
	public class PropertyCollection : CollectionBase
	{

		public int Add(Property value)
		{
			return base.List.Add(value as object);
		}

		public void Remove(Property value)
		{
			base.List.Remove( (object)value);
		}

		public void Insert(int index, Property value)
		{
			base.List.Insert(index, (object)value);
		}

		public bool Contains(Property value)
		{
			return base.List.Contains( (object)value);
		}

		public Property this[int index]
		{
			get { return ( (Property)base.List[index]); }
		}

		public Property GetProperty(string name)
		{
			foreach(Property prop in base.List)
				if(prop.Name == name)
					return prop;
			return null;
		}

		public Property GetPropertyByField(string name)
		{
			foreach(Property prop in base.List)
				if(prop.Field == name)
					return prop;
			return null;
		}
	}
}
