using System;
using System.Globalization;
using Evaluant.Uss.MetaData;

namespace Evaluant.Uss
{
	/// <summary>
	/// Description rsume de IPersistenceProvider.
	/// </summary>
	public interface IPersistenceProvider
	{
		/// <summary>
		/// Initializes the configuration once all properties are loaded.
		/// </summary>
		void InitializeConfiguration();

		/// <summary>
		/// Creates the persistence engine using the properties which are loaded.
		/// </summary>
		/// <returns></returns>
        IPersistenceEngine CreatePersistenceEngine();

		/// <summary>
		/// Registers the meta data.
		/// </summary>
		/// <param name="metadata">The metadata.</param>
		void RegisterMetaData(IMetaData[] metadata);

		CultureInfo Culture { get; set; }
	}
}
