using System;
using System.Collections.Generic;
using System.Text;

using DslModeling = global::Microsoft.VisualStudio.Modeling;
using DslDiagrams = global::Microsoft.VisualStudio.Modeling.Diagrams;

namespace Evaluant.EussDSL
{
    /// <summary>
    /// Redefinition of the serialization of an Entity
    /// </summary>
    public partial class IdentifierSerializer
    {
        private void CustomConstructor()
        {
            DefaultConstructor();
        }

        private string CustomXmlTagName
        {
            get { return DefaultXmlTagName; }
        }

        private string CustomMonikerTagName
        {
            get
            {
                return DefaultMonikerTagName;
            }
        }

        private string CustomMonikerAttributeName
        {
            get { return DefaultMonikerAttributeName; }
        }

        private void CustomRead(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlReader reader)
        {
            //DefaultRead(serializationContext, element, reader);

            // implementation personnalise
            #region Check Parameters
            global::System.Diagnostics.Debug.Assert(serializationContext != null);
            if (serializationContext == null)
                throw new global::System.ArgumentNullException("serializationContext");
            global::System.Diagnostics.Debug.Assert(element != null);
            if (element == null)
                throw new global::System.ArgumentNullException("element");
            global::System.Diagnostics.Debug.Assert(reader != null);
            if (reader == null)
                throw new global::System.ArgumentNullException("reader");
            #endregion


            // on lit "field"
            Identifier instanceOfIdentifier = element as Identifier;
            global::System.Diagnostics.Debug.Assert(instanceOfIdentifier != null, "Expecting an instance of Identifier");

            // field
            if (!serializationContext.Result.Failed)
            {
                string attribfield = reader.GetAttribute("field");
                if (attribfield != null)
                {
                    global::System.String valueOffield;
                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribfield), out valueOffield))
                    {
                        instanceOfIdentifier.field = valueOffield;
                    }
                    else
                    {	// Invalid property value, ignored.
                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "field", typeof(global::System.String), attribfield);
                    }
                }
            }


            // on passe  <generator>
            DslModeling::SerializationUtilities.SkipToFirstChild(reader);

            if (!serializationContext.Result.Failed && !reader.EOF && reader.NodeType == global::System.Xml.XmlNodeType.Element)
            {
                if (string.Compare(reader.LocalName, "Generator", global::System.StringComparison.CurrentCulture) == 0)
                {
                    // generator "name"
                    if (!serializationContext.Result.Failed)
                    {
                        string attribGeneratorName = reader.GetAttribute("name");
                        if (attribGeneratorName != null)
                        {
                            global::System.String valueOfGeneratorName;
                            if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribGeneratorName), out valueOfGeneratorName))
                            {
                                instanceOfIdentifier.GeneratorName = valueOfGeneratorName;
                            }
                            else
                            {	// Invalid property value, ignored.
                                EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "name", typeof(global::System.String), attribGeneratorName);
                            }
                        }
                    }

                    // on passe aux "properties"
                    // Read nested XML elements.
                    if (!serializationContext.Result.Failed)
                    {
                        if (!reader.IsEmptyElement)
                        {
                            //// Read to the start of the first child element.
                            //DslModeling::SerializationUtilities.SkipToFirstChild(reader);

                            //// Read nested XML elements, they can be either properties serialized as XML elements, or child 
                            //// model elements.
                            //while (!serializationContext.Result.Failed && !reader.EOF && reader.NodeType == global::System.Xml.XmlNodeType.Element)
                            //{
                            //    DefaultReadElements(serializationContext, element, reader);
                            //    if (!serializationContext.Result.Failed && !reader.EOF && reader.NodeType == global::System.Xml.XmlNodeType.Element)
                            //    {
                            //        // Encountered one unknown XML element, skip it and keep reading.
                            //        EussDSLSerializationBehaviorSerializationMessages.UnexpectedXmlElement(serializationContext, reader);
                            //        DslModeling::SerializationUtilities.Skip(reader);
                            //    }
                            //}

                            DslModeling::SerializationUtilities.SkipToFirstChild(reader);

                            if(!serializationContext.Result.Failed && !reader.EOF && reader.NodeType == global::System.Xml.XmlNodeType.Element)
                            {
                                //DefaultReadElements(serializationContext, element, reader);
                                //if (!serializationContext.Result.Failed && !reader.EOF && reader.NodeType == global::System.Xml.XmlNodeType.Element)
                                //{
                                //    // Encountered one unknown XML element, skip it and keep reading.
                                //    EussDSLSerializationBehaviorSerializationMessages.UnexpectedXmlElement(serializationContext, reader);
                                //    DslModeling::SerializationUtilities.Skip(reader);
                                //}

                                string attribName = "";

                                attribName = reader.GetAttribute("name");
                                if (attribName != null)
                                {
                                    global::System.String valueOfName;
                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribName), out valueOfName))
                                    {
                                        if (valueOfName == "dbType")
                                        {
                                            if (!serializationContext.Result.Failed)
                                            {
                                                string attribvalue = reader.ReadElementContentAsString(); //reader.GetAttribute("value");
                                                if (attribvalue != null)
                                                {
                                                    global::System.String valueOfvalue;
                                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribvalue), out valueOfvalue))
                                                    {
                                                        instanceOfIdentifier.dbType = valueOfvalue;

                                                        DslModeling::SerializationUtilities.Skip(reader);
                                                    }
                                                    else
                                                    {	// Invalid property value, ignored.
                                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "value", typeof(global::System.String), attribvalue);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {	// Invalid property value, ignored.
                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "name", typeof(global::System.String), attribName);
                                    }

                                    
                                }


                                attribName = reader.GetAttribute("name");
                                if (attribName != null)
                                {
                                    global::System.String valueOfName;
                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribName), out valueOfName))
                                    {
                                        if (valueOfName == "size")
                                        {
                                            if (!serializationContext.Result.Failed)
                                            {
                                                string attribvalue = reader.ReadElementContentAsString(); //reader.GetAttribute("value");
                                                if (attribvalue != null)
                                                {
                                                    global::System.String valueOfvalue;
                                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribvalue), out valueOfvalue))
                                                    {
                                                        instanceOfIdentifier.size = valueOfvalue;

                                                        DslModeling::SerializationUtilities.Skip(reader);
                                                    }
                                                    else
                                                    {	// Invalid property value, ignored.
                                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "value", typeof(global::System.String), attribvalue);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {	// Invalid property value, ignored.
                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "name", typeof(global::System.String), attribName);
                                    }
                                }

                                attribName = reader.GetAttribute("name");
                                if (attribName != null)
                                {
                                    global::System.String valueOfName;
                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribName), out valueOfName))
                                    {
                                        if (valueOfName == "seed")
                                        {
                                            if (!serializationContext.Result.Failed)
                                            {
                                                string attribvalue = reader.ReadElementContentAsString(); //reader.GetAttribute("value");
                                                if (attribvalue != null)
                                                {
                                                    global::System.String valueOfvalue;
                                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribvalue), out valueOfvalue))
                                                    {
                                                        instanceOfIdentifier.seed = valueOfvalue;

                                                        DslModeling::SerializationUtilities.Skip(reader);
                                                    }
                                                    else
                                                    {	// Invalid property value, ignored.
                                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "value", typeof(global::System.String), attribvalue);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {	// Invalid property value, ignored.
                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "name", typeof(global::System.String), attribName);
                                    }
                                }

                                attribName = reader.GetAttribute("name");
                                if (attribName != null)
                                {
                                    global::System.String valueOfName;
                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribName), out valueOfName))
                                    {
                                        if (valueOfName == "increment")
                                        {
                                            if (!serializationContext.Result.Failed)
                                            {
                                                string attribvalue = reader.ReadElementContentAsString(); //reader.GetAttribute("value");
                                                if (attribvalue != null)
                                                {
                                                    global::System.String valueOfvalue;
                                                    if (DslModeling::SerializationUtilities.TryGetValue<global::System.String>(DslModeling::SerializationUtilities.UnescapeXmlString(attribvalue), out valueOfvalue))
                                                    {
                                                        instanceOfIdentifier.increment = valueOfvalue;

                                                        DslModeling::SerializationUtilities.Skip(reader);
                                                    }
                                                    else
                                                    {	// Invalid property value, ignored.
                                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "value", typeof(global::System.String), attribvalue);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {	// Invalid property value, ignored.
                                        EussDSLSerializationBehaviorSerializationMessages.IgnoredPropertyValue(serializationContext, reader, "name", typeof(global::System.String), attribName);
                                    }
                                }
                            }
                        }
                    }
                }
                // fin de <Generator>
                DslModeling::SerializationUtilities.Skip(reader);
            }
            // fin de <Id>
            DslModeling::SerializationUtilities.Skip(reader);
        }

        private static void CustomReadPropertiesFromAttributes(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlReader reader)
        {
            DefaultReadPropertiesFromAttributes(serializationContext, element, reader);
        }

        private static void CustomReadElements(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlReader reader)
        {
            DefaultReadElements(serializationContext, element, reader);
        }

        private DslModeling::ModelElement CustomTryCreateInstance(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader, DslModeling::Partition partition)
        {
            return DefaultTryCreateInstance(serializationContext, reader, partition);
        }

        private DslModeling::ModelElement CustomCreateInstance(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader, DslModeling::Partition partition)
        {
            return DefaultCreateInstance(serializationContext, reader, partition);
        }

        private DslModeling::Moniker CustomTryCreateMonikerInstance(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader, DslModeling::ModelElement sourceRolePlayer, global::System.Guid relDomainClassId, DslModeling::Partition partition)
        {
            return DefaultTryCreateMonikerInstance(serializationContext, reader, sourceRolePlayer, relDomainClassId, partition);
        }

        private DslModeling::Moniker CustomCreateMonikerInstance(DslModeling::SerializationContext serializationContext, global::System.Xml.XmlReader reader, DslModeling::ModelElement sourceRolePlayer, global::System.Guid relDomainClassId, DslModeling::Partition partition)
        {
            return DefaultCreateMonikerInstance(serializationContext, reader, sourceRolePlayer, relDomainClassId, partition);
        }

        private void CustomWrite(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer, DslModeling::RootElementSettings rootElementSettings)
        {
            //DefaultWrite(serializationContext, element, writer, rootElementSettings);


            #region Check Parameters
            global::System.Diagnostics.Debug.Assert(serializationContext != null);
            if (serializationContext == null)
                throw new global::System.ArgumentNullException("serializationContext");
            global::System.Diagnostics.Debug.Assert(element != null);
            if (element == null)
                throw new global::System.ArgumentNullException("element");
            global::System.Diagnostics.Debug.Assert(writer != null);
            if (writer == null)
                throw new global::System.ArgumentNullException("writer");
            #endregion

            // ecrit <Id>
            if (rootElementSettings != null && !string.IsNullOrEmpty(rootElementSettings.SchemaTargetNamespace))
                writer.WriteStartElement(this.XmlTagName, rootElementSettings.SchemaTargetNamespace);
            else
                writer.WriteStartElement(this.XmlTagName);

            // Write version info (in the format 1.2.3.4), if necessary
            if (rootElementSettings != null && rootElementSettings.Version != null)
                writer.WriteAttributeString("dslVersion", rootElementSettings.Version.ToString(4));

            Identifier instanceOfIdentifier = element as Identifier;
            global::System.Diagnostics.Debug.Assert(instanceOfIdentifier != null, "Expecting an instance of Identifier");

            // field
            if (!serializationContext.Result.Failed)
            {
                global::System.String propValue = instanceOfIdentifier.field;
                if (!serializationContext.Result.Failed)
                {
                    writer.WriteAttributeString("field", propValue);
                }
            }

            writer.WriteStartElement("Generator");

            // GeneratorName
            if (!serializationContext.Result.Failed)
            {
                global::System.String propValue = instanceOfIdentifier.GeneratorName;
                if (!serializationContext.Result.Failed)
                {
                    if (propValue != null)// && (serializationContext.WriteOptionalPropertiesWithDefaultValue || string.CompareOrdinal(propValue, "guid") != 0))
                    {	// No need to write the value out if it's the same as default value.
                        writer.WriteAttributeString("name", propValue);
                    }
                }
            }

            if (!serializationContext.Result.Failed)
            {
                // on ecrit les <Property>
                //DefaultWriteElements(serializationContext, element, writer);

                if (!string.IsNullOrEmpty(instanceOfIdentifier.dbType))
                {
                    writer.WriteStartElement("Property");
                    writer.WriteAttributeString("name", "dbType");
                    writer.WriteString(instanceOfIdentifier.dbType);
                    writer.WriteEndElement();
                }

                if (!string.IsNullOrEmpty(instanceOfIdentifier.size))
                {
                    writer.WriteStartElement("Property");
                    writer.WriteAttributeString("name", "size");
                    writer.WriteString(instanceOfIdentifier.size);
                    writer.WriteEndElement();
                }

                if (!string.IsNullOrEmpty(instanceOfIdentifier.seed))
                {
                    writer.WriteStartElement("Property");
                    writer.WriteAttributeString("name", "seed");
                    writer.WriteString(instanceOfIdentifier.seed);
                    writer.WriteEndElement();
                }

                if (!string.IsNullOrEmpty(instanceOfIdentifier.increment))
                {
                    writer.WriteStartElement("Property");
                    writer.WriteAttributeString("name", "increment");
                    writer.WriteString(instanceOfIdentifier.increment);
                    writer.WriteEndElement();
                }
            }

            // fin de <Generator>
            writer.WriteEndElement();

            // fin de <Id>
            writer.WriteEndElement();
        }

        private static void CustomWritePropertiesAsAttributes(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer)
        {
            DefaultWritePropertiesAsAttributes(serializationContext, element, writer);
        }

        private static void CustomWriteElements(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer)
        {
            DefaultWriteElements(serializationContext, element, writer);
        }

        private void CustomWriteMoniker(DslModeling::SerializationContext serializationContext, DslModeling::ModelElement element, global::System.Xml.XmlWriter writer, DslModeling::ModelElement sourceRolePlayer, DslModeling::DomainRelationshipXmlSerializer relSerializer)
        {
            DefaultWriteMoniker(serializationContext, element, writer, sourceRolePlayer, relSerializer);
        }

        private string CustomCalculateQualifiedName(DslModeling::DomainXmlSerializerDirectory directory, DslModeling::ModelElement element)
        {
            return DefaultCalculateQualifiedName(directory, element);
        }

        private string CustomGetMonikerQualifier(DslModeling::DomainXmlSerializerDirectory directory, DslModeling::ModelElement element)
        {
            return DefaultGetMonikerQualifier(directory, element);
        }
    }
}


