using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.Modeling;

using DslModeling = global::Microsoft.VisualStudio.Modeling;
using DslDesign = global::Microsoft.VisualStudio.Modeling.Design;
using DslDiagrams = global::Microsoft.VisualStudio.Modeling.Diagrams;

namespace Evaluant.EussDSL
{
    public static partial class RelationshipNew
    {
        ///<summary>
        /// Called to determine if we can drag from here.
        ///</summary>
        internal static bool CanAcceptSource(ModelElement sourceElement)
        {
            return sourceElement is Entity;
        }
        ///<summary>
        /// Called to determine if we can drag between these.
        ///</summary>
        internal static bool CanAcceptSourceAndTarget(ModelElement sourceElement, ModelElement targetElement)
        {
            return targetElement is Entity;
            // CanAcceptSource already checked
        }
        ///<summary>
        /// Called to perform the connection.
        ///</summary>
        internal static void Connect(ModelElement sourceElement, ModelElement targetElement)
        {
            Entity source = sourceElement as Entity;
            Entity target = targetElement as Entity;

            if (source != null && target != null)
            {
                ReferenceNew newRef = new ReferenceNew(source.Partition, null);
                newRef.entityChild = target.type;
                source.ReferencesNew.Add(newRef);

                GlobalData.demandRelocation = true;

                //ReferenceNewShape sourceShape = null;
                //EntityShape targetShape = null;
                //EntityShape sourceEntityShape = null;

                //foreach (ModelElement obj in source.Partition.ElementDirectory.AllElements)
                //{
                //    if (obj is ReferenceNewShape)
                //    {
                //        if (((ReferenceNewShape)obj).ModelElement is ReferenceNew)
                //        {
                //            if (((ReferenceNew)((ReferenceNewShape)obj).ModelElement).Entity.type == source.type)
                //            {
                //                sourceShape = (ReferenceNewShape)obj;
                //            }
                //        }
                //    }

                //    if (obj is EntityShape)
                //    {
                //        if (((EntityShape)obj).ModelElement is Entity)
                //        {
                //            if (((Entity)((EntityShape)obj).ModelElement).type == source.type)
                //            {
                //                sourceEntityShape = (EntityShape)obj;
                //            }

                //            if (((Entity)((EntityShape)obj).ModelElement).type == target.type)
                //            {
                //                targetShape = (EntityShape)obj;
                //            }
                //        }
                //    }
                //}

                //if (/*sourceShape != null &&*/ targetShape != null)
                //{
                    
                //    //sourceShape.ModelElement = newRef;
                //    //targetShape.ParentShape.NestedChildShapes.Add(sourceShape);

                //    //// Cette version cre et attache correctement les 2 entits 
                //    TargetNewConnector tncNew = new TargetNewConnector(source.Partition);
                //    tncNew.Connect(sourceEntityShape, targetShape);
                //    sourceEntityShape.ParentShape.NestedChildShapes.Add(tncNew);
                //    tncNew.Show();

                //    // le probleme est qu'a ce niveau, sourceshape n'est pas trouve car le directory n'est pas actualis
                //    //TargetNewConnector tncNew = new TargetNewConnector(source.Partition);
                //    //sourceShape = new ReferenceNewShape(source.Partition, null);
                    
                //    //tncNew.Connect(sourceShape, targetShape);
                //    //targetShape.ParentShape.NestedChildShapes.Add(tncNew);
                    
                //    //tncNew.Show();
                //}
            }
        }
    }
}