using System;
using System.Collections.Generic;

using Microsoft.VisualStudio.TestTools.UnitTesting;
using Evaluant.Uss.ObjectContext;
using Evaluant.Uss;


namespace NUnit.Mapping.IdBusiness
{
	/// <summary>
	/// Description rsume de Proxy.
	/// </summary>
	[TestClass]
	public class Fixture
	{
        protected ObjectContext oc;

        public Fixture()
        {
            Evaluant.Uss.SqlMapper.SqlMapperProvider provider = new Evaluant.Uss.SqlMapper.SqlMapperProvider();
            
            provider.ConnectionString = @"Data Source=.;Initial Catalog=uss;Integrated Security=True";
            provider.Dialect = "Evaluant.Uss.SqlMapper.MsSqlDialect";
            provider.Driver = "Evaluant.Uss.SqlMapper.MsSqlDriver";
            provider.MappingFileName = @"..\..\..\NUnit\Mapping\IdBusiness\mapping_1.xml";
            provider.RegisterMetaData(MetaDataFactory.FromAssembly(typeof(Person).Assembly));

            provider.InitializeConfiguration();

            oc = new ObjectService(provider).CreateObjectContext();
        }

        [TestMethod]
        public void Serialize()
        {
            oc.InitializeRepository();

            Person p = new Person();
            p.Name = "Bob";
            p.Age = 23;

            oc.BeginTransaction();
            oc.Serialize(p);
            oc.CommitTransaction();
        }
    }
}
