using System;
using System.Collections.Generic;

using Microsoft.VisualStudio.TestTools.UnitTesting;
using Evaluant.Uss.ObjectContext;
using Evaluant.Uss;


namespace NUnit.Mapping.IdNative
{
	/// <summary>
	/// Description rsume de Proxy.
	/// </summary>
	[TestClass]
	public class Fixture
	{
        protected ObjectContext oc;

        public Fixture()
        {
            Evaluant.Uss.SqlMapper.SqlMapperProvider provider = new Evaluant.Uss.SqlMapper.SqlMapperProvider();
            
            provider.ConnectionString = @"Data Source=.;Initial Catalog=uss;Integrated Security=True";
            provider.Dialect = "Evaluant.Uss.SqlMapper.MsSqlDialect";
            provider.Driver = "Evaluant.Uss.SqlMapper.MsSqlDriver";
            provider.MappingFileName = @"..\..\..\NUnit\Mapping\IdNative\mapping_1.xml";
            provider.RegisterMetaData(MetaDataFactory.FromAssembly(typeof(Person).Assembly));

            provider.InitializeConfiguration();

            oc = new ObjectService(provider).CreateObjectContext();
        }

        [TestMethod]
        public void Serialize()
        {
            oc.InitializeRepository();

            // Create
            Person p = new Person();
            p.Name = "Bob";
            p.Age = 23;

            oc.BeginTransaction();
            oc.Serialize(p);
            oc.CommitTransaction();

            Assert.AreEqual(2, p.Id);

            // Create and update
            Person p2 = new Person();
            p2.Name = "John";

            Vehicule smart = new Vehicule();
            smart.Model = "Smart";
            p2.Vehicules.Add(smart);
            
            oc.BeginTransaction();
            oc.Serialize(p2);
            oc.CommitTransaction();

            Assert.AreEqual(3, p2.Id);

            p2.Age = 30;
            oc.BeginTransaction();
            oc.Serialize(p2);
            oc.CommitTransaction();

            Assert.AreEqual(0, smart.VehiculeId);
        }  
    }
}
