using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Evaluant.Uss;
using Evaluant.Uss.SqlMapper;

namespace TestUSS.Db2
{
	/// <summary>
	/// Description rsume de TestSqlPersistenceEngine.
	/// </summary>
	[TestClass]
	public class TestSqlMapperSpecific : Common
	{
		protected override void CreatePersistenceEngine()
		{
            pef = XmlConfigLoader.LoadXmlConfig("engines.config", "Db2Specific");
		}

        [TestMethod]
        public override void Simple()
        {
            base.Simple();
        }

        [TestMethod]
        public override void TestKindDotName()
        {
            base.TestKindDotName();
        }

        [TestMethod]
        public override void Ids()
        {
            base.Ids();
        }

        [TestMethod]
        public override void Update()
        {
            base.Update();
        }

        [TestMethod]
        public override void LoadScalar()
        {
            base.LoadScalar();
        }

        [TestMethod]
        public override void OPath()
        {
            base.OPath();
        }

        [TestMethod]
        public override void MultiThreading()
        {
            base.MultiThreading();
        }

        [TestMethod]
        public void TestTimeType()
        {
            TimeSpan ts=DateTime.Now.TimeOfDay;
            Entity e = new Entity("TimeType");
            e.AddValue("Time", ts, typeof(TimeSpan));

            Transaction t = new Transaction();
            t.Serialize(e);
            t.Commit(pe);

            EntitySet es=pe.Load("TimeType");

            Assert.AreEqual(1,es.Count);

            Assert.AreEqual(ts.Ticks, ((TimeSpan)es[0].GetValue("Time", typeof(TimeSpan))).Ticks);
        }

        [TestMethod]
        public void TestExecuteSql()
        {
            Entity p1 = new Entity("Person");
            p1.AddValue("Firstname", "John");
            p1.Id = "p1";

            Transaction t = new Transaction();
            t.Serialize(p1);
            t.Commit(pe);

            Assert.AreEqual(1, ((SqlMapperPersistenceEngine)pe).ExecuteSql("SELECT * FROM Person").Rows.Count);
        }
	}
}
