using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;

using GeneratedModel;
using EmployeeNamespace;

using NUnit.Framework;

namespace UseCases.InheritanceFromGeneratedClass
{
	/// <summary>
	/// Description rsume de InheritanceFromGeneratedClass.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void SetUp()
		{
			pmf = new ObjectService("UseCases.config", "InheritanceFromGeneratedClass");
			pmf.AddAssembly(typeof(Person).Assembly);
			pm = pmf.CreateObjectContext();

			pm.InitializeRepository();
		}

		[Test]
		public void SerializePersons()
		{

			Person p1 = new Person();
			p1.Name = "Moos";
			p1.Firstname = "John";

			Person p2 = new Person();
			p2.Name = "Latimer";
			p2.Firstname = "Harry";

			pm.BeginTransaction();
			pm.Serialize(p1);
			pm.Serialize(p2);
			pm.CommitTransaction();

			pm.Clear();

			IList person1List = pm.Load(typeof(Person), "[Name='Moos']");
			Assert.AreEqual(1, person1List.Count);
			Assert.AreEqual("Moos", ((Person)person1List[0]).Name);

			IList person2List = pm.Load(typeof(Person), "[Name='Latimer']");
			Assert.AreEqual(1, person2List.Count);
//			Assert.AreEqual("Latimer", ((Person)person2List[0]).Name);
		}

		[Test]
		public void SerializeEmployees()
		{

			Employee e1 = new Employee();
			e1.Name = "Wang";
			e1.Firstname = "Yang";

			Employee e2 = new Employee();
			e2.Name = "Suyama";
			e2.Firstname = "Michael";

			pm.BeginTransaction();
			pm.Serialize(e1);
			pm.Serialize(e2);
			pm.CommitTransaction();

			IList employee1List = pm.Load(typeof(Employee), "[Name='Wang']");
			Assert.AreEqual(1, employee1List.Count);
			Assert.AreEqual("Wang", ((Person)employee1List[0]).Name);

			IList employee2List = pm.Load(typeof(Employee), "[Name='Suyama']");
			Assert.AreEqual(1, employee2List.Count);
			Assert.AreEqual("Suyama", ((Person)employee2List[0]).Name);
		}
	}
}
