using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using ManyToOne;

using NUnit.Framework;

namespace UseCases.ManyToOneModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void Main()
		{
			pmf = new ObjectService("UseCases.config", "ManyToOneModel");
			pmf.AddAssembly(typeof(Company).Assembly);
			pm = pmf.CreateObjectContext();

			Company c1 = new Company();
			c1.Name = "Around the Horn";
			c1.Chairman = "Thomas Hardy";
			c1.Address = "120 Hanover Sq.";
			c1.City = "London";

			Company c2 = new Company();
			c2.Name = "B's Beverages";
			c2.Chairman = "Victoria Ashworth";
			c2.Address = "Fauntleroy Circus";
			c2.City = "London";

			CountableCabinet cb = new CountableCabinet();
			cb.Name = "Tom Mendel";
			cb.City = "London";

			c1.CountableCabinet = cb;
			c2.CountableCabinet = cb;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(c1);
			pm.Serialize(c2);
			pm.CommitTransaction();
		}

		[Test]
		public void TestCompanies()
		{
			pm.Clear();

			IList countablecabinets = pm.Load(typeof(CountableCabinet), "[Name='Tom Mendel']");
			Assert.AreEqual(1, countablecabinets.Count);
			CountableCabinet countableCabinet = (CountableCabinet)countablecabinets[0];

			/// TODO: Add tests for LoadParents
//			Assert.AreEqual(2, countableCabinet.Parents.GetCompanies().Length);
			
			IList companies = pm.Load(typeof(Company));
			Assert.AreEqual(2, companies.Count);
			foreach(Company company in companies)
				Assert.AreEqual("Tom Mendel", company.CountableCabinet.Name);
		}
	}
}
