using System;

using UniversalStorageServices;
using UniversalStorageServices.PersistenceManager;

using NUnit.Framework;

namespace UseCases.OneToOneMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		[Test]
		public void Main()
		{
			IPersistenceEngineFactory pef = 
				XmlConfigLoader.LoadXmlConfig("UseCases.config", "OneToOneMapping");
			IPersistenceEngine pe = pef.CreatePersistenceEngine();
			
			//Bug with InitializeRepository
			pe.InitializeRepository();

			Entity j1 = new Entity("Job");
			j1.AddValue("Name", "Accountant");

			Entity j2 = new Entity("Job");
			j2.AddValue("Name", "Worker");

			Entity p1 = new Entity("Person");
			p1.AddValue("Name", "Anders");
			p1.AddValue("Job", j1);

			Entity p2 = new Entity("Person");
			p2.AddValue("Name", "Dodsworth");
			p2.AddValue("Job", j2);

			Transaction t = new Transaction();
			t.Serialize(p1);
			t.Serialize(p2);
			pe.Commit(t);

			EntitySet persons = pe.Load("Person", "Job");

			Assert.AreEqual(2, persons.Count);
			Assert.IsNotNull(((Entity)persons[0]).GetEntitySet("Job"));
			Assert.IsNotNull(((Entity)persons[1]).GetEntitySet("Job"));
		}
	}
}
