using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using OneToOne;

using NUnit.Framework;

namespace UseCases.OneToOneModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void SetUp()
		{
			pmf = 
				new ObjectService("UseCases.config", "OneToOneModel");
			pmf.AddAssembly(typeof(Person).Assembly);
			pm = pmf.CreateObjectContext();

			Person p = new Person();
			p.Name = "Accorti";
			p.Firstname = "Paolo";
			p.Birthday = new DateTime(1970, 05, 23);

			Job j = new Job();
			j.Title = "Accountant";
			j.StartDate = new DateTime(2000, 01, 01);

			p.Job = j;

			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();
		}

		[Test]
		public void Test()
		{
			pm.Clear();

			IList persons = pm.Load(typeof(Person));
			IList jobs = pm.Load(typeof(Job));
			
			Assert.AreEqual(1, persons.Count);
			Assert.AreEqual(1, jobs.Count);

			/// TODO: Add tests for LoadParents
//			Assert.AreEqual(typeof(Person), ((Job)jobs[0]).Parents.GetPerson().GetType());
			Assert.AreEqual(typeof(Job), ((Person)persons[0]).Job.GetType());

			Assert.AreEqual("Accorti", ((Person)persons[0]).Name);
			Assert.AreEqual("Accountant", ((Person)persons[0]).Job.Title);
		}
	}
}
