using System;
using System.Collections;
using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;
using SimpleClass;

using NUnit.Framework;

namespace UseCases.SimpleClassModel
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		private ObjectService pmf;
		private ObjectContext pm;

		[SetUp]
		public void Main()
		{
			pmf = new ObjectService("UseCases.config", "SimpleClassModel");

			pmf.AddAssembly(typeof(Person).Assembly);

			pm = pmf.CreateObjectContext();

			Person p = new Person();
			p.Name = "Moos";
			p.Firstname = "Hanna";
			p.Birthday = new DateTime(1970, 10, 25);
			
			pm.InitializeRepository();

			pm.BeginTransaction();
			pm.Serialize(p);
			pm.CommitTransaction();
		}

		[Test]
		public void TestPerson()
		{
			pm.Clear();

			IList persons = pm.Load(typeof(Person));

			Assert.AreEqual(1, persons.Count);
			Person person = (Person)persons[0];
			Console.WriteLine(person.Name);
		}
	}
}
