using System;
using System.Collections;

using Evaluant.Uss;
using Evaluant.Uss.ObjectContext;

using SimpleObject;

using NUnit.Framework;

namespace UseCases.SimpleObjectMapping
{
	/// <summary>
	/// Description rsume de Program.
	/// </summary>
	/// 
	[TestFixture]
	public class Program
	{
		[Test]
		public void Main()
		{
			ObjectService pmf = 
				new ObjectService("UseCases.config", "SimpleObjectMapping");
			pmf.AddAssembly(typeof(Employee).Assembly);
			ObjectContext pm = pmf.CreateObjectContext();

			pm.InitializeRepository();

			Employee e = new Employee();
			e.LastName = "Dodsworth";
			
			pm.BeginTransaction();
			pm.Serialize(e);
			pm.CommitTransaction();

			pm.Clear();

			IList employees = pm.Load(typeof(Employee));
			Assert.AreEqual(1, employees.Count);
			Assert.AreEqual("Dodsworth", ((Employee)employees[0]).LastName);
		}
	}
}
